#include-once
#include <FileConstants.au3>
#include <MsgBoxConstants.au3>

#include '..\..\..\..\_build\include\MiscLib.au3'

; Constants for parsing the function or libfunction full text files.
Global Enum $FUNCTIONLIST_NAME, _
		$FUNCTIONLIST_SYNTAX, _
		$FUNCTIONLIST_DESCRIPTION, _
		$FUNCTIONLIST_MAX

Global Const $FUNCTIONLIST = @ScriptDir & "\..\functions.txt", _
		$KEYWORDLIST = @ScriptDir & "\..\keywords.txt", _
		$LIBFUNCTIONLIST = @ScriptDir & "\..\libfunctions.txt", _
		$MACROLIST = @ScriptDir & "\..\macros.txt", _
		$SENDSTRINGLIST = @ScriptDir & "\..\sendstrings.txt", _
		$FUNCTIONLIST_FULL = @ScriptDir & "\..\function_full.txt", _
		$LIBFUNCTIONLIST_FULL = @ScriptDir & "\..\libfunctions_full.txt", _
		$MACROLIST_FULL = @ScriptDir & "\..\macros_full.txt"

; ------------------------------------------------------------------------------
; Join two function arrays into one.
; ------------------------------------------------------------------------------
Func ArrayJoin(ByRef $aArray_1, ByRef $aArray_2)
	Local $iIndex = UBound($aArray_1), $iUBound = UBound($aArray_2)
	If $iIndex > 0 And $iUBound > 0 Then
		ReDim $aArray_1[$iIndex + $iUBound]
		For $i = 0 To $iUBound - 1
			$aArray_1[$iIndex] = $aArray_2[$i]
			$iIndex += 1
		Next
		$aArray_2 = 0
	EndIf

	Return True
EndFunc   ;==>ArrayJoin

; ------------------------------------------------------------------------------
; Create the editor syntax stylesheet.
; ------------------------------------------------------------------------------
Func GenerateEditorSyntax($sOutput, $sHeader, ByRef $aKeywords, ByRef $sKeywordList, ByRef $aMacros, ByRef $sMacroList, ByRef $aFunctions, ByRef $sFunctionList, $sAppend = "=")
	; Copy the header.txt file to the output file.
	FileCopy($sHeader, $sOutput, $FC_OVERWRITE)

	; Keywords
	For $i = 0 To UBound($aKeywords) - 1
		$sKeywordList &= $aKeywords[$i] & $sAppend & @CRLF
	Next

	; Macros
	For $i = 0 To UBound($aMacros) - 1
		$sMacroList &= $aMacros[$i] & $sAppend & @CRLF
	Next

	; Functions
	For $i = 0 To UBound($aFunctions) - 1
		$sFunctionList &= $aFunctions[$i] & $sAppend & @CRLF
	Next

	Local $hFileOpen = FileOpen($sOutput, $FO_APPEND)
	If $hFileOpen > -1 Then
		FileWrite($hFileOpen, $sKeywordList & $sMacroList & $sFunctionList)
		FileClose($hFileOpen)
	EndIf

	Return True
EndFunc   ;==>GenerateEditorSyntax
